<?php

namespace Drupal\eca\Attribute;

use Drupal\Core\StringTranslation\TranslatableMarkup;

/**
 * Defines an extra Action attribute object for ECA.
 */
#[\Attribute(\Attribute::TARGET_CLASS)]
readonly class EcaAction {

  /**
   * Constructs an Action attribute.
   */
  public function __construct(
    public ?TranslatableMarkup $description = NULL,
    public ?string $eca_version_introduced = NULL,
  ) {}

  /**
   * Get an array with all defined properties.
   *
   * @return array
   *   The array with all defined properties.
   */
  public function properties(): array {
    $properties = [];
    if ($this->description) {
      $properties['description'] = $this->description;
    }
    if ($this->eca_version_introduced) {
      $properties['eca_version_introduced'] = $this->eca_version_introduced;
    }
    return $properties;
  }

}
